diff --git a/zebra/main.c b/zebra/main.c
index 81a30664453a..c8f33d8d6dc6 100644
--- a/zebra/main.c
+++ b/zebra/main.c
@@ -204,6 +204,14 @@ void zebra_finalize(struct event *dummy)
 {
 	zlog_info("Zebra final shutdown");
 
+	struct vrf *vrf;
+	struct interface *ifp;
+
+	RB_FOREACH (vrf, vrf_id_head, &vrfs_by_id)
+		FOR_ALL_INTERFACES (vrf, ifp)
+		if (IS_ZEBRA_IF_BOND((ifp)))
+			zebra_l2if_update_bond(ifp, false);
+
 	vrf_terminate();
 
 	ns_walk_func(zebra_ns_early_shutdown, NULL, NULL);
